#include <avr/io.h>
#include "dcf77.h"
#include "sbit.h"
#include "label.h"
#include "leds.h"
#include "clock.h"

uint8_t dcf77_bit;
uint8_t dcf_data_last;
uint8_t dcf_started;
uint16_t filter;
uint8_t filter_ready;
uint16_t i;
uint16_t count_pulse_on;

uint16_t count_pause_detection;

uint8_t databits[100];
uint8_t databit_counter;

volatile uint8_t ready_to_sync;

void dcf77_decode(void) {
	count_pause_detection++;
	if(count_pause_detection>=1100) {
		if(clock_already_updated==0) LED04=1;
		dcf77_sync();
		count_pause_detection=0;
	}
	if(clock_already_updated==0) LED02=DCF_DATA;
	if(DCF_DATA == 1 && dcf_data_last == 0) {
		dcf_started=1;
	}
	if(dcf_started==1) {
		if(filter_ready==0) {
			i++;
			if(DCF_DATA==1) {
				filter++;
			}
			if(i==10) {
				//bin_minute(filter);
				if(filter>6) {
					filter_ready=1;
				} else {
					dcf_started=0;
				}									
				i=0;
				filter=0;
			}
		} else {
			count_pause_detection=0;
			//LED03=1;
			i++;
			if(DCF_DATA==1) {
				count_pulse_on++;
			}
			if(i==190) { //10ms durch Filter verloren
				if(count_pulse_on>100) {
					dcf77_bit=1;
				} else {
					dcf77_bit=0;
				}	
			
				databits[databit_counter]=dcf77_bit;
				databit_counter++;
				if(clock_already_updated==0) LED01=dcf77_bit;
			
				i=0;
				count_pulse_on=0;	
				dcf_started=0;	
				filter_ready=0;	
			}
		}		
	}
	dcf_data_last = DCF_DATA;
}

uint8_t oddeven;
uint8_t odd;
void dcf77_sync(void) {
	if(databit_counter==59) {
		//alle bits empfangen! (59 (obwohl array 0-58), da erst geladen und dann auf jeden fall incrementiert wird...)
		if(databits[0]==0) {
			//Prfbit Minute
			oddeven=0;
			if(databits[21]==1) oddeven++;
			if(databits[22]==1) oddeven++;
			if(databits[23]==1) oddeven++;
			if(databits[24]==1) oddeven++;
			if(databits[25]==1) oddeven++;
			if(databits[26]==1) oddeven++;
			if(databits[27]==1) oddeven++;
			if(oddeven&1) {
				//ungerade
				odd=1;
			} else {
				//gerade
				odd=0;
			}
			if(databits[28]==odd) {
				//Prfbit Stunde
				oddeven=0;
				if(databits[29]==1) oddeven++;
				if(databits[30]==1) oddeven++;
				if(databits[31]==1) oddeven++;
				if(databits[32]==1) oddeven++;
				if(databits[33]==1) oddeven++;
				if(databits[34]==1) oddeven++;
				if(oddeven&1) {
					//ungerade
					odd=1;
				} else {
					//gerade
					odd=0;
				}
					if(databits[35]==odd) {
						//Prfbit Datum
						oddeven=0;
						if(databits[36]==1) oddeven++;
						if(databits[37]==1) oddeven++;
						if(databits[38]==1) oddeven++;
						if(databits[39]==1) oddeven++;
						if(databits[40]==1) oddeven++;
						if(databits[41]==1) oddeven++;
						if(databits[42]==1) oddeven++;
						if(databits[43]==1) oddeven++;
						if(databits[44]==1) oddeven++;
						if(databits[45]==1) oddeven++;
						if(databits[46]==1) oddeven++;
						if(databits[47]==1) oddeven++;
						if(databits[48]==1) oddeven++;
						if(databits[49]==1) oddeven++;
						if(databits[50]==1) oddeven++;
						if(databits[51]==1) oddeven++;
						if(databits[52]==1) oddeven++;
						if(databits[53]==1) oddeven++;
						if(databits[54]==1) oddeven++;
						if(databits[55]==1) oddeven++;
						if(databits[56]==1) oddeven++;
						if(databits[57]==1) oddeven++;
						if(oddeven&1) {
							//ungerade
							odd=1;
						} else {
							//gerade
							odd=0;
						}
						if(databits[58]==odd) {
							if(clock_already_updated==0) LED05=1;
							dcf77_update_clock();
						}						
					}					
			}
		}
	}
	databit_counter=0;
}

volatile uint8_t clock_already_updated;
uint8_t temp;
void dcf77_update_clock(void) {
	clock_already_updated=1;
	
	sec=0;
	temp=0;
	if(databits[21]==1) temp = temp+1;
	if(databits[22]==1) temp = temp+2;
	if(databits[23]==1) temp = temp+4;
	if(databits[24]==1) temp = temp+8;
	if(databits[25]==1) temp = temp+10;
	if(databits[26]==1) temp = temp+20;
	if(databits[27]==1) temp = temp+40;
	min=temp;
	temp=0;
	if(databits[29]==1) temp = temp+1;
	if(databits[30]==1) temp = temp+2;
	if(databits[31]==1) temp = temp+4;
	if(databits[32]==1) temp = temp+8;
	if(databits[33]==1) temp = temp+10;
	if(databits[34]==1) temp = temp+20;
	hou=temp;
}