#include <avr/io.h>
#include <avr/interrupt.h>
#include "timer.h"
#include "clock.h"
#include "dcf77.h"
#include "sbit.h"
#include "label.h"
#include "leds.h"

void init_timer0(void) {
	TCCR0 |= (1<<CS01) | (1<<CS00);	//Prescaler 64
	TIMSK |= (1<<TOIE0);	//Interrupt bei Timer Overflow
	TCNT0 = 0xBC;
	sei();					//Interrupts aktivieren
}

volatile uint16_t i_msec;
ISR(TIMER0_OVF_vect) {
	TCNT0 = 0xBC; //muss unbedingt als erstes in Interrupt, damit Zeit stimmt (da sonst die Befehlsverzgerung noch mit drin ist...)
	i_msec++;
	if(i_msec==999) {
		i_msec=0;
		if(clock_already_updated==1) tick();
	}	
	if(ADC>60) {
		if(clock_already_updated==0) LED06=1;
		if(J1==0) alldisabled=0;
	} else {
		if(clock_already_updated==0) LED06=0;
		if(J1==0) alldisabled=1;
	}
	dcf77_decode();	
	//1ms - http://www.dieelektronikerseite.de/Tools/Timer-Rechner.htm	
	
	if(LED17==0) {
		if(clock_already_updated==0) LED17=1;
	} else {
		if(clock_already_updated==0) LED17=0;
	}
}